<?php

/**
 * Plugin Name: Domain Mapping Auto Park to cPanel
 * Plugin URI: https://hostmijnpagina.nl
 * Description: Connects WPMUdev Domain Mapping with cPanel
 * Author: Sybre Waaijer
 * Version: 1.0.0
 * Author URI: https://cyberwire.nl
 */

/* 

== USAGE ==

1. ENABLE: WHM -> Tweak Settings -> Domains -> Allow domain parking across accounts
2. ENABLE: WHM -> Tweak Settings -> System -> cPanel & WHM API shell (for developers)
3. GET: WHM -> Remote Access Key
4. ENABLE: API Shell (for developers) to the desired user package in Feature Manager -> EDIT
5. ADD: The package with API Shell (for developers) to the desires user in Edit a Package -> EDIT -> Feature list
6. edit the following lines: $hostip, $root_user, $cpanel_user, $whmhash
7. network activate the plugin or do your magic with Pro Sites auto activate plugin (with plugins menu hidden that is)

SECURITY:
8. Add only your used IPs (and server IPs) in WHM -> Host Access Control
9. Disable expose_php
10. Super Admins can read plugin files like this one within WordPress. Do not make people Super Admins if you do not trust them with computers and security.

WARNING: 
YOU are responsible for your servers security and the posibility to make this plugin readable or not. YOUR root account CAN be compromised if your security is flawed. I suggest iThemes Security to lower your chances of this happening. 

DISCLAIMER:
This feature uses live data from your server. API function calls may change or delete data on your server, which can cause your server to fail. USE AT OWN RISK.

*/

add_action( 'domainmapping_added_domain', 'hmpl_auto_park_domain', 10, 1);
function hmpl_auto_park_domain($domain) {

	/* START EDITING HERE */

	/* change these values if needed */
	$hostip = '192.168.123.123';
	$root_user = 'root';
	$cpanel_user = 'cpanelusername';

	/* The contents of /root/.accesshash (you can also fetch this from WHM -> Remote Access Key) - Just paste as is and keep the breaks */
	
	$whmhash = "AVeryLongHashWhich
BreaksALot-ReplaceAll
AndKeepTheBreaksSoYou
WontKillYourDomainMap
ping12345678901234567";
	
	/* STOP EDITING HERE */

	$topdomain = ''; /* LEAVE EMPTY */
	
	$parkdomain = $domain;
	
	require_once("includes/xmlapi.php");
	$xmlapi = new xmlapi($hostip);
	$xmlapi->hash_auth($root_user, $whmhash);
  	
	$xmlapi->park($cpanel_user, $parkdomain, $topdomain);

}